diff --git a/test/unit/commands/setup/web_bundle_test.rb b/test/unit/commands/setup/web_bundle_test.rb
new file mode 100644
index 000000000..7adadc727
--- /dev/null
+++ b/test/unit/commands/setup/web_bundle_test.rb
@@ -0,0 +1,101 @@
+require "test_helper"
+require "hive/commands/setup/web_bundle"
+
+class SetupWebBundleTest < Minitest::Test
+  include HiveTestHelper
+
+  def make_app(dir)
+    FileUtils.mkdir_p(File.join(dir, "config"))
+    File.write(File.join(dir, "config", "application.rb"), "# app marker\n")
+    FileUtils.mkdir_p(File.join(dir, "bin"))
+    File.write(File.join(dir, "bin", "rails"), "#!/bin/sh\nexit 0\n")
+    FileUtils.chmod(0755, File.join(dir, "bin", "rails"))
+    dir
+  end
+
+  def test_resolution_order_env_then_managed_then_source
+    with_tmp_global_config do |home|
+      env_dir = make_app(File.join(home, "env-web"))
+      managed = Hive::Paths.managed_web_dir
+
+      with_env("HIVEBOX_WEB_APP_DIR" => env_dir) do
+        assert_equal env_dir, Hive::Commands::Setup::WebBundle.new.resolve_app_dir,
+                     "HIVEBOX_WEB_APP_DIR must win over managed + source"
+      end
+
+      # No env override, but a populated managed dir → managed wins.
+      make_app(managed)
+      assert_equal managed, Hive::Commands::Setup::WebBundle.new.resolve_app_dir
+
+      # No env, no managed app → the sibling source checkout resolves.
+      FileUtils.rm_rf(managed)
+      source = File.expand_path("../../../../web", __dir__)
+      assert_equal source, Hive::Commands::Setup::WebBundle.new.resolve_app_dir
+    end
+  end
+
+  def test_marker_write_read_and_mismatch
+    with_tmp_dir do |dir|
+      bundle = Hive::Commands::Setup::WebBundle.new
+      refute bundle.version_mismatch?(dir), "no marker = no mismatch"
+
+      bundle.write_marker(dir)
+      assert_equal Hive::VERSION, bundle.marker_version(dir)
+      refute bundle.version_mismatch?(dir)
+
+      File.write(bundle.marker_path(dir), "0.0.1\n")
+      assert bundle.version_mismatch?(dir), "a stale marker must mismatch"
+    end
+  end
+
+  def test_provision_fetches_when_no_app_resolves
+    with_tmp_global_config do |home|
+      calls = []
+      fetcher = ->(dir) { calls << [ :fetch, dir ]; make_app(dir); { ok: true, message: "fetched" } }
+      bundle = Hive::Commands::Setup::WebBundle.new(fetcher: fetcher, runner: ->(_argv) { [ "", true ] })
+      with_replaced_singleton_method(bundle, :resolve_app_dir, -> { nil }) do
+        result = bundle.provision
+        assert result[:ok], result[:message]
+        assert_equal 1, calls.size, "no app resolved → must fetch"
+        assert_equal Hive::Paths.managed_web_dir, calls.first[1]
+        assert_equal Hive::VERSION, bundle.marker_version(Hive::Paths.managed_web_dir)
+      end
+    end
+  end
+
+  def test_provision_fetch_failure_produces_exact_fix_command
+    with_tmp_global_config do
+      fetcher = ->(_dir) { { ok: false, message: "run: git clone --depth 1 --branch v#{Hive::VERSION} …" } }
+      bundle = Hive::Commands::Setup::WebBundle.new(fetcher: fetcher, runner: ->(_argv) { [ "", true ] })
+      with_replaced_singleton_method(bundle, :resolve_app_dir, -> { nil }) do
+        result = bundle.provision
+        refute result[:ok]
+        assert_match(/git clone/, result[:message])
+      end
+    end
+  end
+
+  def test_stale_managed_bundle_is_refetched
+    with_tmp_global_config do |home|
+      managed = Hive::Paths.managed_web_dir
+      make_app(managed)
+      File.write(File.join(managed, Hive::Commands::Setup::WebBundle::MARKER_FILENAME), "0.0.1\n")
+
+      calls = []
+      fetcher = ->(dir) { calls << [ :fetch, dir ]; { ok: true, message: "fetched" } }
+      bundle = Hive::Commands::Setup::WebBundle.new(fetcher: fetcher, runner: ->(_argv) { [ "", true ] })
+      with_replaced_singleton_method(bundle, :resolve_app_dir, -> { managed }) do
+        bundle.provision
+      end
+      assert_equal 1, calls.size, "a stale managed bundle must be re-fetched"
+    end
+  end
+
+  def test_managed_dir_predicate
+    with_tmp_global_config do
+      bundle = Hive::Commands::Setup::WebBundle.new
+      assert bundle.managed_dir?(Hive::Paths.managed_web_dir)
+      refute bundle.managed_dir?(File.join(Hive::Paths.managed_web_dir, "..", "other"))
+    end
+  end
+end
diff --git a/test/unit/commands/setup_test.rb b/test/unit/commands/setup_test.rb
new file mode 100644
index 000000000..f3ecd6682
--- /dev/null
+++ b/test/unit/commands/setup_test.rb
@@ -0,0 +1,212 @@
+require "test_helper"
+require "hive/commands/setup"
+
+class SetupTest < Minitest::Test
+  include HiveTestHelper
+
+  def ok_result(name)
+    Hive::Commands::Setup::Deps::Result.new(
+      name: name, ok: true, blocked: false, found: "x", required: "any", message: "ok", fix: nil
+    )
+  end
+
+  def blocked_result(name)
+    Hive::Commands::Setup::Deps::Result.new(
+      name: name, ok: false, blocked: true, found: nil, required: "any",
+      message: "missing", fix: "brew install #{name}"
+    )
+  end
+
+  def missing_result(name)
+    Hive::Commands::Setup::Deps::Result.new(
+      name: name, ok: false, blocked: false, found: nil, required: "any",
+      message: "missing", fix: "brew install #{name}"
+    )
+  end
+
+  # Fake deps / web_bundle / runner / health_probe recording calls.
+  def build_setup(script: {}, dep_results: [ ok_result("ruby") ], health: [ true, "ok" ], json: true, **opts)
+    calls = []
+    runner = ->(argv) do
+      calls << argv
+      if argv[1] == "daemon" && argv[2] == "status"
+        # A canned, consistent daemon status so the orchestrator's status
+        # step passes without a real daemon.
+        return [ JSON.generate("ok" => true, "running" => true, "consistent" => true), true ]
+      end
+
+      script.fetch(argv.join(" ")) { [ "", true ] }
+    end
+    web_bundle = Object.new
+    web_bundle.define_singleton_method(:provision) { calls << [ :provision ]; { ok: true, message: "bundled", app_dir: "/app" } }
+    deps = Object.new
+    deps.define_singleton_method(:check) { dep_results }
+    setup = Hive::Commands::Setup.new(
+      json: json,
+      non_interactive: true,
+      project_path: Dir.pwd,
+      input: StringIO.new,
+      output: StringIO.new,
+      summary_io: StringIO.new,
+      deps: deps,
+      web_bundle: web_bundle,
+      runner: runner,
+      health_probe: -> { health },
+      **opts
+    )
+    [ setup, calls ]
+  end
+
+  # Setup with a fully controlled daemon-status response (canned JSON + exit
+  # code) so the `ensure_daemon` status/consistency handling is testable
+  # without a real daemon.
+  def build_setup_with_daemon_status(status_json, status_ok)
+    runner = ->(argv) do
+      return [ status_json, status_ok ] if argv[1] == "daemon" && argv[2] == "status"
+
+      [ "", true ]
+    end
+    web_bundle = Object.new
+    web_bundle.define_singleton_method(:provision) { { ok: true, message: "bundled", app_dir: "/app" } }
+    deps = Object.new
+    deps.define_singleton_method(:check) { [ ok_result("ruby") ] }
+    Hive::Commands::Setup.new(
+      json: true, non_interactive: true, project_path: Dir.pwd,
+      input: StringIO.new, output: StringIO.new, summary_io: StringIO.new,
+      deps: deps, web_bundle: web_bundle, runner: runner,
+      health_probe: -> { [ true, "ok" ] }
+    )
+  end
+
+  def test_orchestrates_steps_in_dependency_order
+    with_tmp_global_config do
+      setup, calls = build_setup
+      out, = capture_io { setup.call }
+      payload = JSON.parse(out)
+
+      step_names = payload.fetch("steps").map { |s| s["name"] }
+      assert_equal %w[deps qmd web_bundle daemon enroll web], step_names,
+                   "setup must run the steps in dependency order"
+
+      # The runner sees daemon install before status, then init/enroll, then web install.
+      runner_calls = calls.reject { |c| c == [ :provision ] }
+      assert_includes runner_calls, [ setup.send(:hive_bin), "daemon", "install", "--force" ]
+      assert_includes runner_calls, [ setup.send(:hive_bin), "daemon", "status", "--json" ]
+      assert_includes runner_calls, [ setup.send(:hive_bin), "web", "install" ]
+    end
+  end
+
+  def test_envelope_matches_hive_setup_schema_shape
+    with_tmp_global_config do
+      setup, = build_setup
+      out, = capture_io { setup.call }
+      payload = JSON.parse(out)
+      assert_equal "hive-setup", payload["schema"]
+      assert_equal Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-setup"), payload["schema_version"]
+      assert_equal true, payload["ok"]
+      assert_equal %w[claude codex], payload["backends"], "non-interactive defaults are claude+codex"
+      assert_equal "http://127.0.0.1:4567", payload["web_url"]
+      assert_kind_of Array, payload["deps"]
+      assert_kind_of Array, payload["steps"]
+      assert_kind_of Array, payload["warnings"]
+    end
+  end
+
+  def test_non_tty_uses_default_backends
+    with_tmp_global_config do
+      setup, = build_setup
+      capture_io { setup.call }
+      assert_equal %w[claude codex], Hive::Config.load_global_agents
+    end
+  end
+
+  def test_setup_persists_local_loopback_web_contract
+    with_tmp_global_config do
+      setup, = build_setup
+      capture_io { setup.call }
+      cfg = Hive::Config.load_global_web
+      assert_equal "loopback", cfg["auth_mode"],
+                   "a fresh `hive setup` must persist web.auth_mode=loopback, not the owner default"
+      assert_equal "127.0.0.1", cfg["bind"]
+      assert_equal 4567, cfg["port"]
+    end
+  end
+
+  def test_daemon_status_exit_1_not_running_is_not_a_hard_failure
+    with_tmp_global_config do
+      setup = build_setup_with_daemon_status(JSON.generate("ok" => true, "running" => false, "consistent" => true), false)
+      result = setup.send(:ensure_daemon)
+      assert result[:ok], "exit-1 (not running) must not fail the daemon step: #{result[:message]}"
+      assert_match(/consistent/, result[:message])
+    end
+  end
+
+  def test_daemon_status_inconsistent_is_a_hard_failure
+    with_tmp_global_config do
+      setup = build_setup_with_daemon_status(JSON.generate("ok" => true, "running" => true, "consistent" => false), true)
+      result = setup.send(:ensure_daemon)
+      refute result[:ok]
+      assert_match(/inconsistent/, result[:message])
+    end
+  end
+
+  def test_daemon_status_consistent_null_is_unverifiable_not_pass
+    with_tmp_global_config do
+      setup = build_setup_with_daemon_status(JSON.generate("ok" => true, "running" => true, "consistent" => nil), true)
+      result = setup.send(:ensure_daemon)
+      refute result[:ok], "consistent:null must not be reported as pass"
+      assert_match(/could not be verified/, result[:message])
+    end
+  end
+
+  def test_blocked_external_cli_is_a_warning_not_a_failure
+    with_tmp_global_config do
+      setup, = build_setup(dep_results: [ ok_result("ruby"), blocked_result("claude") ])
+      out, = capture_io { setup.call }
+      payload = JSON.parse(out)
+      assert_equal true, payload["ok"], "blocked external CLIs must not fail the local bring-up"
+      assert payload["warnings"].any? { |w| w.include?("claude") }
+    end
+  end
+
+  def test_missing_hard_dependency_fails_setup
+    with_tmp_global_config do
+      setup, = build_setup(dep_results: [ ok_result("ruby"), missing_result("git") ])
+      err = assert_raises(Hive::Error) do
+        capture_io { setup.call }
+      end
+      assert_match(/incomplete/, err.message)
+    end
+  end
+
+  def test_failed_step_fails_setup
+    with_tmp_global_config do
+      # daemon install fails → step ok:false → overall ok:false.
+      script = { "#{Hive::InvokedBinary.path || 'hive'} daemon install --force" => [ "", false ] }
+      setup, = build_setup(script: script)
+      err = assert_raises(Hive::Error) do
+        capture_io { setup.call }
+      end
+      assert_match(/incomplete/, err.message)
+    end
+  end
+
+  def test_enroll_prefers_enable_for_registered_project
+    with_tmp_global_config do |home|
+      # Register a project whose path == the setup project_path (Dir.pwd here is
+      # the repo root; use a path that will match via a tmp project).
+      with_tmp_dir do |proj|
+        FileUtils.mkdir_p(File.join(home))
+        cfg = { "registered_projects" => [ { "name" => "demo", "path" => proj } ] }
+        File.write(File.join(home, "config.yml"), cfg.to_yaml)
+
+        setup, calls = build_setup
+        setup.instance_variable_set(:@project_path, File.expand_path(proj))
+        capture_io { setup.call }
+        bin = setup.send(:hive_bin)
+        assert_includes calls, [ bin, "daemon", "enable", "demo" ],
+                        "an already-registered project must be enrolled via `hive daemon enable`, not re-init"
+      end
+    end
+  end
+end
diff --git a/test/unit/commands/web/service_installer_test.rb b/test/unit/commands/web/service_installer_test.rb
new file mode 100644
index 000000000..4d79ec0e1
--- /dev/null
+++ b/test/unit/commands/web/service_installer_test.rb
@@ -0,0 +1,156 @@
+require "test_helper"
+require "hive/commands/web/service_installer"
+
+class WebServiceInstallerTest < Minitest::Test
+  include HiveTestHelper
+
+  def installer_with(dir, hive:, app_dir:, **opts)
+    FileUtils.mkdir_p(File.dirname(hive))
+    File.write(hive, "#!/bin/sh\n")
+    FileUtils.chmod(0755, hive)
+    Hive::Commands::Web::ServiceInstaller.new(
+      host_os: "linux-gnu",
+      home: dir,
+      binary_path: hive,
+      systemctl_available: false,
+      **opts
+    ).tap do |installer|
+      installer.define_singleton_method(:resolved_app_dir) { app_dir }
+    end
+  end
+
+  def test_linux_writes_systemd_unit_with_resolved_binary_and_app_dir
+    with_tmp_dir do |dir|
+      hive = File.join(dir, "bin", "hive")
+      app_dir = File.join(dir, "share", "hive", "web")
+      installer = installer_with(dir, hive: hive, app_dir: app_dir)
+
+      installer.install!(autostart: false)
+      unit = File.join(dir, ".config/systemd/user/hive-web.service")
+      assert File.exist?(unit)
+      body = File.read(unit)
+      assert_includes body, "ExecStart=#{hive} web --bind 127.0.0.1",
+                      "ExecStart must run the web tier in the foreground on the loopback bind"
+      assert_includes body, "Environment=HIVEBOX_WEB_APP_DIR=#{app_dir}",
+                      "the unit must bake the resolved Rails app dir so the service survives login/reboot"
+      assert_includes body, "Environment=PATH=",
+                      "minimal PATH must be rewritten so the web tier's bin/hive shebang resolves a Ruby with gem deps"
+    end
+  end
+
+  def test_linux_autostart_invokes_enable_when_systemd_available
+    with_tmp_dir do |dir|
+      commands = []
+      hive = File.join(dir, "bin", "hive")
+      FileUtils.mkdir_p(File.dirname(hive))
+      File.write(hive, "#!/bin/sh\n")
+      FileUtils.chmod(0755, hive)
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "linux",
+        home: dir,
+        binary_path: hive,
+        systemctl_available: true,
+        runner: ->(argv) { commands << argv }
+      )
+
+      result = installer.install!(autostart: true)
+      assert_equal :written, result.kind
+      assert_includes commands, %w[systemctl --user daemon-reload]
+      assert_includes commands, %w[systemctl --user enable --now hive-web]
+    end
+  end
+
+  def test_linux_without_systemd_writes_unit_and_reports_autostart_unavailable
+    with_tmp_dir do |dir|
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "linux",
+        home: dir,
+        binary_path: "/tmp/hive",
+        systemctl_available: false,
+        runner: ->(_argv) { false }
+      )
+
+      result = installer.install!(autostart: true)
+      assert_equal :autostart_unavailable, result.kind
+      assert File.exist?(File.join(dir, ".config/systemd/user/hive-web.service"))
+      assert installer.messages.any? { |msg| msg.include?("hive web start") },
+             "the graceful-degradation message should point at `hive web start`"
+    end
+  end
+
+  def test_macos_writes_plist_with_resolved_binary_and_app_dir
+    with_tmp_dir do |dir|
+      hive = File.join(dir, ".local", "bin", "hive")
+      app_dir = File.join(dir, ".local", "share", "hive", "web")
+      installer = installer_with(dir, hive: hive, app_dir: app_dir)
+      installer.instance_variable_set(:@host_os, "darwin23")
+
+      installer.install!(autostart: false)
+      plist = File.join(dir, "Library/LaunchAgents/local.hive-web.plist")
+      assert File.exist?(plist)
+      body = File.read(plist)
+      assert_includes body, "<string>#{hive}</string>"
+      assert_includes body, "<string>web</string>"
+      assert_includes body, "<string>--bind</string>"
+      assert_includes body, "<string>127.0.0.1</string>"
+      assert_includes body, "<string>#{app_dir}</string>",
+                      "launchd plist must bake HIVEBOX_WEB_APP_DIR as an absolute path"
+      assert_includes body, "<key>RunAtLoad</key>"
+    end
+  end
+
+  def test_drifted_existing_unit_is_not_overwritten_without_force
+    with_tmp_dir do |dir|
+      unit = File.join(dir, ".config/systemd/user/hive-web.service")
+      FileUtils.mkdir_p(File.dirname(unit))
+      File.write(unit, "custom\n")
+      installer = installer_with(dir, hive: File.join(dir, "bin", "hive"), app_dir: "/app")
+
+      result = installer.install!(autostart: false)
+      assert_equal :drifted, result.kind
+      assert_equal "custom\n", File.read(unit)
+      assert installer.messages.any? { |msg| msg.include?("hive web install --force") }
+    end
+  end
+
+  def test_force_overwrites_drifted_unit_and_writes_backup
+    with_tmp_dir do |dir|
+      unit = File.join(dir, ".config/systemd/user/hive-web.service")
+      FileUtils.mkdir_p(File.dirname(unit))
+      File.write(unit, "previous-stale-content\n")
+      installer = installer_with(dir, hive: File.join(dir, "bin", "hive"), app_dir: "/app")
+
+      result = installer.install!(autostart: false, force: true)
+      assert_equal :upgraded, result.kind
+      backups = Dir["#{unit}.bak-*"]
+      assert_equal 1, backups.size
+      assert_equal "previous-stale-content\n", File.read(backups.first)
+      assert_includes File.read(unit), "ExecStart="
+    end
+  end
+
+  def test_service_state_reports_install_and_enable_state
+    with_tmp_dir do |dir|
+      installer = installer_with(dir, hive: File.join(dir, "bin", "hive"), app_dir: "/app")
+      state = installer.service_state
+      refute state["service_installed"]
+
+      installer.install!(autostart: false)
+      state = installer.service_state
+      assert state["service_installed"]
+      assert_equal "linux", state["platform"]
+      assert_equal File.join(dir, ".config/systemd/user/hive-web.service"), state["unit_path"]
+    end
+  end
+
+  def test_app_dir_falls_back_to_managed_dir_when_unresolved
+    with_tmp_global_config do
+      installer = Hive::Commands::Web::ServiceInstaller.new(host_os: "linux")
+      # Stub the resolver to simulate a host with no source checkout / env
+      # override: the managed dir is the correct fallback.
+      with_replaced_singleton_method(Hive::Commands::Web, :rails_app_dir, -> { nil }) do
+        assert_equal Hive::Paths.managed_web_dir, installer.resolved_app_dir
+      end
+    end
+  end
+end
diff --git a/test/unit/config_web_test.rb b/test/unit/config_web_test.rb
new file mode 100644
index 000000000..b8550e618
--- /dev/null
+++ b/test/unit/config_web_test.rb
@@ -0,0 +1,62 @@
+require "test_helper"
+require "hive/config"
+
+# U1 / R4 — persisting the local loopback web contract. `hive setup` and
+# `hive web install` write `web.auth_mode: "loopback"` (plus the canonical
+# loopback bind/port) into the global config so a fresh local install is
+# not left gated behind the GitHub owner flow.
+class ConfigWebTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_write_local_web_loopback_persists_the_loopback_contract
+    with_tmp_global_config do |home|
+      Hive::Config.write_local_web_loopback!
+
+      cfg = Hive::Config.load_global_web
+      assert_equal "loopback", cfg["auth_mode"]
+      assert_equal "127.0.0.1", cfg["bind"]
+      assert_equal 4567, cfg["port"]
+      assert Hive::Config.local_web_no_auth?(cfg), "the persisted block must resolve to loopback no-auth"
+
+      data = YAML.safe_load(File.read(File.join(home, "config.yml")))
+      assert_equal "loopback", data.dig("web", "auth_mode")
+    end
+  end
+
+  def test_write_global_web_preserves_operator_sibling_keys
+    with_tmp_global_config do |home|
+      File.write(File.join(home, "config.yml"), {
+        "registered_projects" => [],
+        "web" => { "origin" => "https://box.example.com", "github" => { "client_id" => "custom" } }
+      }.to_yaml)
+
+      Hive::Config.write_local_web_loopback!
+
+      cfg = Hive::Config.load_global_web
+      assert_equal "https://box.example.com", cfg["origin"], "operator origin must be preserved"
+      assert_equal "custom", cfg.dig("github", "client_id"), "operator github.client_id must be preserved"
+      assert_equal "loopback", cfg["auth_mode"]
+    end
+  end
+
+  def test_write_global_web_rejects_pre_existing_non_hash_web_block
+    with_tmp_global_config do |home|
+      File.write(File.join(home, "config.yml"), {
+        "registered_projects" => [],
+        "web" => "not-a-hash"
+      }.to_yaml)
+
+      err = assert_raises(Hive::ConfigError) { Hive::Config.write_local_web_loopback! }
+      assert_match(/web .* must be a Hash/, err.message)
+    end
+  end
+
+  def test_write_global_web_validates_the_merged_block
+    with_tmp_global_config do
+      err = assert_raises(Hive::ConfigError) do
+        Hive::Config.write_global_web!("auth_mode" => "not-a-mode")
+      end
+      assert_match(/auth_mode/, err.message)
+    end
+  end
+end
diff --git a/test/unit/daemon/consistency_test.rb b/test/unit/daemon/consistency_test.rb
new file mode 100644
index 000000000..5c8065881
--- /dev/null
+++ b/test/unit/daemon/consistency_test.rb
@@ -0,0 +1,138 @@
+require "test_helper"
+require "hive/daemon/consistency"
+
+class DaemonConsistencyTest < Minitest::Test
+  include HiveTestHelper
+
+  FakeInstaller = Struct.new(:resolved_binary, :target_path, :envelope_platform)
+
+  def build(installer:, pid: nil, exe_reader: nil, version_probe: nil)
+    Hive::Daemon::Consistency.new(
+      installer: installer,
+      pid: pid,
+      exe_reader: exe_reader,
+      version_probe: version_probe
+    )
+  end
+
+  def test_matching_binary_with_no_unit_and_no_pid_is_consistent
+    installer = FakeInstaller.new("/usr/local/bin/hive", "/nonexistent-unit", "linux")
+    result = build(installer: installer).probe
+
+    assert_equal "/usr/local/bin/hive", result["binary"]
+    assert_equal Hive::VERSION, result["binary_version"]
+    assert_nil result["unit_binary"], "no unit file → no unit drift"
+    assert_nil result["running_binary"]
+    assert result["consistent"]
+  end
+
+  def test_stale_execstart_binary_is_detected
+    with_tmp_dir do |dir|
+      unit = File.join(dir, "hive-daemon.service")
+      File.write(unit, "ExecStart=/usr/bin/hive daemon start\n")
+      installer = FakeInstaller.new("/usr/local/bin/hive", unit, "linux")
+
+      result = build(installer: installer).probe
+      assert_equal "/usr/bin/hive", result["unit_binary"]
+      refute result["consistent"], "a stale /usr/bin/hive ExecStart must be detected"
+    end
+  end
+
+  def test_stale_running_version_is_detected
+    installer = FakeInstaller.new("/usr/local/bin/hive", nil, "linux")
+    result = build(
+      installer: installer,
+      pid: 123,
+      exe_reader: ->(_pid) { "/usr/local/bin/hive" },
+      version_probe: ->(_bin) { "0.2.0" }
+    ).probe
+
+    refute result["consistent"]
+    assert_equal "0.2.0", result["running_version"], "a stale daemon --version must surface"
+  end
+
+  def test_running_binary_drift_is_detected
+    installer = FakeInstaller.new("/usr/local/bin/hive", nil, "linux")
+    result = build(
+      installer: installer,
+      pid: 123,
+      exe_reader: ->(_pid) { "/usr/bin/hive" },
+      version_probe: ->(_bin) { Hive::VERSION }
+    ).probe
+
+    refute result["consistent"], "a running daemon from a different binary must be detected"
+    assert_equal "/usr/bin/hive", result["running_binary"]
+  end
+
+  def test_matching_running_binary_and_version_is_consistent
+    installer = FakeInstaller.new("/usr/local/bin/hive", nil, "linux")
+    result = build(
+      installer: installer,
+      pid: 123,
+      exe_reader: ->(_pid) { "/usr/local/bin/hive" },
+      version_probe: ->(_bin) { Hive::VERSION }
+    ).probe
+
+    assert result["consistent"]
+  end
+
+  def test_ps_fallback_reads_hive_script_argument
+    with_tmp_dir do |dir|
+      fake_exe = File.join(dir, "bin", "hive")
+      FileUtils.mkdir_p(File.dirname(fake_exe))
+      File.write(fake_exe, "#!/bin/sh\n")
+      FileUtils.chmod(0755, fake_exe)
+
+      installer = FakeInstaller.new("/usr/local/bin/hive", nil, "linux")
+      consistency = build(installer: installer)
+      # `ps` is not on PATH in minimal CI images — stub Open3.capture2 to
+      # exercise the fallback parser (script-argument scan, not the first
+      # token — which is the ruby interpreter for a shebang script).
+      status = Struct.new(:success?).new(true)
+      with_replaced_singleton_method(Open3, :capture2, ->(*_args) { [ "ruby #{fake_exe} daemon start\n", status ] }) do
+        assert_equal fake_exe, consistency.send(:read_exe_via_ps, 123),
+                     "ps fallback must select the hive script argument, not the ruby interpreter"
+      end
+    end
+  end
+
+  def test_read_process_exe_reads_cmdline_not_exe_for_script_daemon
+    with_tmp_dir do |dir|
+      script = File.join(dir, "hive")
+      File.write(script, "#!/usr/bin/env ruby\nsleep 30\n")
+      FileUtils.chmod(0755, script)
+
+      pid = Process.spawn(script, "daemon", "start")
+      begin
+        sleep 0.1
+        consistency = build(installer: FakeInstaller.new(script, nil, "linux"))
+        exe = consistency.send(:read_process_exe, pid)
+        assert_equal script, exe,
+                     "/proc/<pid>/cmdline must resolve the hive script, never the ruby interpreter (/exe)"
+      ensure
+        Process.kill("KILL", pid) rescue nil
+        Process.waitpid(pid) rescue nil
+      end
+    end
+  end
+
+  def test_launchd_plist_binary_is_parsed
+    with_tmp_dir do |dir|
+      plist = File.join(dir, "local.hive-daemon.plist")
+      File.write(plist, <<~XML)
+        <plist version="1.0"><dict>
+        <key>ProgramArguments</key>
+        <array>
+          <string>/bin/sh</string><string>-c</string>
+          <string>[ -x "$0" ] || exit 0; exec "$0" "$@"</string>
+          <string>/usr/local/bin/hive</string>
+        </array>
+        </dict></plist>
+      XML
+      installer = FakeInstaller.new("/opt/homebrew/bin/hive", plist, "macos")
+      result = build(installer: installer).probe
+      assert_equal "/usr/local/bin/hive", result["unit_binary"]
+      refute result["consistent"], "a plist binary differing from the resolved brew binary must drift"
+    end
+  end
+end
diff --git a/test/unit/openclaw_skills_test.rb b/test/unit/openclaw_skills_test.rb
index eb700e97e..e519b71e9 100644
--- a/test/unit/openclaw_skills_test.rb
+++ b/test/unit/openclaw_skills_test.rb
@@ -23,7 +23,7 @@ class OpenClawSkillsTest < Minitest::Test
 
     assert_equal "hive", metadata.fetch("name")
     assert_equal CLAWHUB_DESCRIPTION, metadata.fetch("description")
-    assert_equal "0.1.1", metadata.fetch("version")
+    assert_equal "0.1.2", metadata.fetch("version")
     assert_equal true, metadata.fetch("user-invocable")
     assert_equal HOMEPAGE, openclaw_metadata.fetch("homepage")
     assert_equal true, openclaw_metadata.fetch("always"), "umbrella skill must remain visible for setup"
diff --git a/test/unit/paths_test.rb b/test/unit/paths_test.rb
index 80ee2b5be..a5885575b 100644
--- a/test/unit/paths_test.rb
+++ b/test/unit/paths_test.rb
@@ -51,6 +51,20 @@ class PathsTest < Minitest::Test
     end
   end
 
+  def test_managed_web_dir_lives_under_data_home
+    with_xdg_home do |dir|
+      assert_equal File.join(dir, "data", "hive", "web"), Hive::Paths.managed_web_dir
+    end
+  end
+
+  def test_managed_web_dir_collapses_under_hive_home_override
+    with_tmp_dir do |dir|
+      with_env("HIVE_HOME" => File.join(dir, "legacy"), "XDG_DATA_HOME" => File.join(dir, "data")) do
+        assert_equal File.join(dir, "legacy", "web"), Hive::Paths.managed_web_dir
+      end
+    end
+  end
+
   def test_legacy_registry_migrates_once_to_xdg_config
     with_tmp_dir do |dir|
       home = File.join(dir, "home")
